package org.jeecg.modules.stm.project.create.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.project.create.service.IStProjectCreApproveService;
import org.jeecg.modules.stm.project.create.entity.StProjectCreApprove;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 项目立项审核
 * @Author: jeecg-boot
 * @Date:   2023-08-13
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/project.create/stProjectCreApprove")
@Slf4j
public class StProjectCreApproveController extends JeecgController<StProjectCreApprove, IStProjectCreApproveService> {
	@Autowired
	private IStProjectCreApproveService stProjectCreApproveService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stProjectCreApprove
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "项目立项审核-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<StProjectCreApprove>> queryPageList(StProjectCreApprove stProjectCreApprove,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StProjectCreApprove> queryWrapper = QueryGenerator.initQueryWrapper(stProjectCreApprove, req.getParameterMap());
		Page<StProjectCreApprove> page = new Page<StProjectCreApprove>(pageNo, pageSize);
		IPage<StProjectCreApprove> pageList = stProjectCreApproveService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stProjectCreApprove
	 * @return
	 */
	@AutoLog(value = "项目立项审核-添加")
	  
	@RequiresPermissions("project.create:st_project_cre_approve:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StProjectCreApprove stProjectCreApprove) {
		stProjectCreApproveService.save(stProjectCreApprove);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stProjectCreApprove
	 * @return
	 */
	@AutoLog(value = "项目立项审核-编辑")
	  
	@RequiresPermissions("project.create:st_project_cre_approve:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StProjectCreApprove stProjectCreApprove) {
		stProjectCreApproveService.updateById(stProjectCreApprove);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "项目立项审核-通过id删除")
	  
	@RequiresPermissions("project.create:st_project_cre_approve:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stProjectCreApproveService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "项目立项审核-批量删除")
	  
	@RequiresPermissions("project.create:st_project_cre_approve:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stProjectCreApproveService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "项目立项审核-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<StProjectCreApprove> queryById(@RequestParam(name="id",required=true) String id) {
		StProjectCreApprove stProjectCreApprove = stProjectCreApproveService.getById(id);
		if(stProjectCreApprove==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stProjectCreApprove);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stProjectCreApprove
    */
    @RequiresPermissions("project.create:st_project_cre_approve:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StProjectCreApprove stProjectCreApprove) {
        return super.exportXls(request, stProjectCreApprove, StProjectCreApprove.class, "项目立项审核");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("project.create:st_project_cre_approve:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StProjectCreApprove.class);
    }

}
